
CREATE TABLE IF NOT EXISTS im_ok_normal_table (
    i bigserial primary key,
    o text default random()::text
);

CREATE TABLE  IF NOT EXISTS im_ok_no_serial (
    i bigint primary key,
    o text default random()::text,
    d timestamp default clock_timestamp()
);

CREATE TABLE IF NOT EXISTS im_ok_but_im_not_published (
    i bigserial  primary key
);

CREATE TABLE IF NOT EXISTS im_ok_unique (
    i bigserial,
    o text default random()::text,
    UNIQUE(i)
);


CREATE TABLE IF NOT EXISTS im_ok_unique_comp (
    i bigserial,
    o double precision default random(),
    UNIQUE(i,o)
);

-- Testing sequences that are part of auto-serial
CREATE TABLE IF NOT EXISTS im_ok_but_two_serials ( 
    i bigserial primary key,
    f serial,
    o text default random()::text
);

-- It does not need to initialize the sequence!
-- It requires a different way to check this, as it conforms the 
-- new SQL standard
CREATE TABLE IF NOT EXISTS im_ok_fancy_auto_generated(
    i bigint GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
    f text default random()::text
);

-- Avoids changing ids on the fly, always system-consistent.
-- This may should be the mode for logical replication
CREATE TABLE IF NOT EXISTS im_ok_fancy_auto_generated_always(
    i bigint GENERATED ALWAYS AS IDENTITY PRIMARY KEY,
    f text default random()::text
);


CREATE TABLE im_not_ok_root_partition (
    group_id char(2), 
    stamp timestamp without time zone DEFAULT clock_timestamp()
) PARTITION BY LIST(group_id);
CREATE TABLE im_ok_partition_0 PARTITION OF im_not_ok_root_partition (unique(stamp))
  FOR VALUES IN ('P0');
CREATE TABLE im_ok_partition_1 PARTITION OF im_not_ok_root_partition (unique(stamp))
  FOR VALUES IN ('P1');
CREATE TABLE im_ok_partition_2 PARTITION OF im_not_ok_root_partition (unique(stamp))
  FOR VALUES IN ('P2');

CREATE INDEX  ON im_ok_partition_0 (stamp);
CREATE INDEX  ON im_ok_partition_1 (stamp);
CREATE INDEX  ON im_ok_partition_2 (stamp);



--
-- NOT OK section
--


CREATE TABLE  IF NOT EXISTS im_not_ok_lo (
    i bigserial primary key,
    f oid -- large object
);

CREATE TABLE  IF NOT EXISTS im_not_ok_lo_with_oids (
    i bigserial primary key,
    f oid -- large object
) WITH OIDS;


CREATE TABLE IF NOT EXISTS im_not_ok_no_replica_identity (
    x bigserial ,
    o text default random()::text,
    d timestamp default clock_timestamp()
);

-- CREATE INDEX im_not_ok_no_replica_identity_partial_index ON im_not_ok_no_replica_identity(x) WHERE x > 2;
-- test=# ALTER TABLE im_not_ok_no_replica_identity REPLICA IDENTITY USING INDEX im_not_ok_no_replica_identity_partial_index;
-- ERROR:  cannot use non-unique index "im_not_ok_no_replica_identity_partial_index" as replica identity


CREATE TABLE im_not_ok_root_partition_not_ok_partitions (
    group_id char(2), 
    stamp timestamp without time zone DEFAULT clock_timestamp()
) PARTITION BY LIST(group_id);
CREATE TABLE im_not_ok_partition_0 PARTITION OF im_not_ok_root_partition_not_ok_partitions
  FOR VALUES IN ('P0');
CREATE TABLE im_not_ok_partition_1 PARTITION OF im_not_ok_root_partition_not_ok_partitions
  FOR VALUES IN ('P1');
CREATE TABLE im_not_ok_partition_2 PARTITION OF im_not_ok_root_partition_not_ok_partitions
  FOR VALUES IN ('P2');

CREATE INDEX  ON im_not_ok_partition_0 (stamp);
CREATE INDEX  ON im_not_ok_partition_1 (stamp);
CREATE INDEX  ON im_not_ok_partition_2 (stamp);
-- test=# CREATE PUBLICATION p_test4 FOR TABLE im_not_ok_root_partition_not_ok_partitions;
-- ERROR:  "im_not_ok_root_partition_not_ok_partitions" is a partitioned table
-- DETAIL:  Adding partitioned tables to publications is not supported.
-- HINT:  You can add the table partitions individually.
